      subroutine runcoupl(ig,p,rg)
c----------------------------------------------------------------------c
c Returns a complex running coupling rg at the scale p^2
c
c Input: ig=1,2,3,... - running coupling options, 
c                       should be implemented by the user,
c        p - four momentum incoming to the vertex.
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 19 March, 2015; modified on 
c 9-11 Feb. 2016: the EM pion form factor implemented
c----------------------------------------------------------------------c

      use inprms 
      use couplsmkk
      use dase ! 9 Feb. 2016

      implicit none

      integer :: ig,first=1
      real(dp) :: p(0:3),s,ppthrs
      complex(dp) :: rg,fpikk
      save first,ppthrs

      if (first == 1) then
c Define necessary options for fpikk, transferred through dase:
       DSET='CMD2'
       iso=2
       iopt=11
       first=0
       ppthrs=(2.d0*mpi)**2
      end if

      s=p(0)**2-p(1)**2-p(2)**2-p(3)**2

c      write(*,*)'s:',s-ppthrs,ig

      if (ig == 1) then
       if (s > ppthrs) then
        rg=app*fpikk(s)       ! 9 Feb. 2016
       else
        rg=app                ! 11 Feb. 2016
       end if
      else if (ig == 2) then  ! 11 Feb. 2016
       if (s > ppthrs) then
        rg=aapp*fpikk(s)**2
       else
        rg=aapp
       end if
      else if (ig == 3) then  ! 17 Feb. 2016
       if (s > ppthrs) then
         rg=aapp*fpikk(s)
       else
        rg=aapp
       end if
      else
       write(*,*)'runcoupl.f: ig=',ig,' is not implemented'
      end if

      end subroutine runcoupl
